#ifndef _MAIN_H
#define _MAIN_H

#include "stm32f4xx.h"
#include <CoOS.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

//======================================================================
// Definition global defines
//----------------------------------------------------------------------
#define   RTOS_COOS

#define   OK       (0)
#define   ERROR    (-1)

#define   ON       (!(OFF))
#define   OFF      (0)

#define   MUTEX_INIT(mutex)       static volatile int mutex=0
#define   MUTEX_UNLOCK(mutex)     mutex=0
#ifdef    RTOS_COOS
  #define MUTEX_WAITLOCK(mutex)   do{while(mutex){CoTickDelay(1);}mutex=1;}while(0)
#else
  #define MUTEX_WAITLOCK(mutex)   do{while(mutex);mutex=1;}while(0)
#endif

//======================================================================
// Definition of my favorite types
//----------------------------------------------------------------------
typedef signed char          s08;
typedef signed short         s16;
typedef signed int           s32;
typedef signed long long     s64;
typedef unsigned char        u08;
typedef unsigned short       u16;
typedef unsigned int         u32;
typedef unsigned long long   u64;

#endif // _MAIN_H
